/** \file pclOpEmit.h

    \brief Operation to emit particles.

    \see http://www.mijagourlay.com/

    \author Copyright 2009-2012 Dr. Michael Jason Gourlay; All rights reserved.  Contact me at mijagourlay.com for licensing.
*/
#ifndef PARTICLE_OPERATION_EMIT_H
#define PARTICLE_OPERATION_EMIT_H

#include "particleOperation.h"

/** Operation to emit particles.
*/
class PclOpEmit : public IParticleOperation
{
    public:
        PclOpEmit()
            : mEmitRate( 60.0f )
            , mRemainder( 0.0f )
        {}

        VIRTUAL_CONSTRUCTORS( PclOpEmit ) ;

        void Operate( VECTOR< Particle > & particles , float timeStep , unsigned uFrame ) ;

        static void Emit( VECTOR< Particle > & particles , const UniformGridGeometry & uniformGrid , unsigned multiplier , const VECTOR< Particle > * vortons ) ;

        Particle    mTemplate   ;   ///< Default values for new particle
        Particle    mSpread     ;   ///< Range of values for new particle
        float       mEmitRate   ;   ///< Particles per second to emit
        float       mRemainder  ;   ///< Fractional particles remaining.
} ;

#endif
